<script setup>
import { useGeneral } from "@/Composable/General";
import AuthenticatedLayout from "@/Layouts/AuthenticatedLayout.vue";
import { Link, useForm } from "@inertiajs/vue3";
import Pagination from "@/Components/PaginationLinks.vue";


const { deleteFunction } = useGeneral();

defineProps({
    categories: Object,
});

const form = useForm({
    row_per_page: null,
    searchData: null,
    selectedColumn: null,
    sortDirection: null,

});

const submit = () => {
    form.get(route('category.show'),
        {
            preserveState: true,
        });
}

const sortkey = (columnname,orderby) => {
    form.selectedColumn = columnname;
    form.sortDirection = orderby;
    submit();
}

const perPage = () => {
    form.row_per_page = document.getElementById("row_per_page").value;
    submit();
}

</script>

<template>
    <Head title="Index" />
    <AuthenticatedLayout>
        <template #header>
            <h2 class="font-semibold text-xl text-gray-800 leading-tight">category</h2>
        </template>
        <div class="row">
            <div class="col-12">
                <div class="page-title-right">
                    <ol class="breadcrumb m-0">
                        <li class="breadcrumb-item">
                            <a href="javascript: void(0);">category</a>
                        </li>
                        <li class="breadcrumb-item active">Listing</li>
                    </ol>
                </div>
            </div>
        </div>
        <div class="container-fluid mt-3">
            <!-- Base Example -->
            <div class="accordion" id="default-accordion-example">
                <div class="accordion-item">
                    <h2 class="accordion-header" id="headingOne">
                        <button class="accordion-button" type="button" data-bs-toggle="collapse"
                            data-bs-target="#collapseOne" aria-expanded="true" aria-controls="collapseOne">
                            Serach filters
                        </button>
                    </h2>
                    <div id="collapseOne" class="accordion-collapse collapse show" aria-labelledby="headingOne"
                        data-bs-parent="#default-accordion-example">
                        <div class="accordion-body">
                            <div class="row">
                                <div class="col-sm-3">
                                    <input type="text" class="form-control" placeholder="Name"
                                        v-model="form.searchData" />
                                </div>
                            </div>
                        </div>
                        <div class="row m-2">
                            <div class="col-sm-3">
                                <button class="btn btn-primary" type="submit" name="Search"
                                    @click="submit">Search</button>
                                <Link :href="route('category.show')" class="btn border-success ms-2">Discard</Link>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="row mt-3">
                <div class="col-lg-12">
                    <div class="card" id="tasksList">
                        <div class="card-header border-0">
                            <div class="d-flex align-items-center">
                                <h5 class="card-title mb-0 flex-grow-1">
                                    <div class="col-sm-1">
                                        <select name="row_per_page" id="row_per_page" class="form-control" @change="perPage">
                                            <option value="10">10</option>
                                            <option value="20">20</option>
                                            <option value="30">30</option>
                                            <option value="40">40</option>
                                            <option value="50">50</option>
                                        </select>
                                    </div>
                                </h5>
                                <div class="flex-shrink-0">
                                    <div class="d-flex flex-wrap gap-2">
                                        <Link class="btn btn-soft-primary" :href="route('category.create')"><i
                                            class="ri-add-line align-bottom me-1"></i>Add Category</Link>
                                        <button class="btn btn-soft-secondary" id="remove-actions"
                                            onClick="deleteMultiple()">
                                            <i class="ri-delete-bin-2-line"></i>
                                        </button>
                                    </div>

                                </div>
                            </div>
                        </div>
                        <!--end card-body-->
                        <div class="card-body">
                            <div class="table-responsive table-card mb-4">
                                <table class="table align-middle table-nowrap mb-0" id="tasksTable">
                                    <thead class="table-light text-muted">
                                        <tr>
                                            <th>
                                                ID
                                                <span @click="sortkey('id','desc')" class="float-end">
                                                    <i class="ri-arrow-down-s-fill " :class="form.selectedColumn == 'id' && form.sortDirection == 'desc' ? 'text-danger' : 'text-secondary'"></i>
                                                </span>
                                                <span @click="sortkey('id', 'asc')" class="float-end">
                                                    <i class="ri-arrow-up-s-fill " :class="form.selectedColumn == 'id' && form.sortDirection == 'asc' ? 'text-danger' : 'text-secondary'"></i>
                                                </span>
                                              
                                            </th>
                                            <th>Name
                                                <span @click="sortkey('category_name','asc')" class="float-end"><i
                                                        class=" ri-arrow-up-s-fill" :class="form.selectedColumn == 'category_name' && form.sortDirection == 'asc' ? 'text-danger' : 'text-secondary'"></i></span>
                                                <span @click="sortkey('category_name','desc')" class="float-end"><i
                                                        class="ri-arrow-down-s-fill" :class="form.selectedColumn == 'category_name' && form.sortDirection == 'desc' ? 'text-danger' : 'text-secondary'"></i></span>
                                            </th>
                                            <th>Action</th>
                                        </tr>
                                    </thead>
                                    <tbody v-if="categories.length == 0">
                                        <tr class="text-center">
                                            <td colspan="8">
                                                No Data Found
                                            </td>
                                        </tr>
                                    </tbody>
                                    <tbody class="list form-check-all" v-else>
                                        <tr v-for="category in categories.data" :key="category.id" v-if="categories.data.length > 0 ">
                                            <td>{{ category.id }}</td>
                                            <td>{{ category.category_name }}</td>
                                            <td>
                                                <Link :href="route('category.edit', category.ulid)"><i
                                                    class="ri-pencil-line fs-4 text-success me-1"></i></Link>
                                                <button class="border-0 bg-white"><i
                                                        class="ri-delete-bin-5-line fs-4 text-danger"
                                                        @click="deleteFunction(route('category.delete', category.ulid))"></i></button>
                                            </td>
                                        </tr>

                                        <tr v-else class="text-center">
                                            <td colspan="8">
                                                No Data Found
                                            </td>
                                        </tr>
                                    </tbody>
                                </table>

                                <div v-if="categories.data" class="w-full flex justify-center mt-3 me-3">
                                    <Pagination :links="categories.links" />
                                </div>
                            </div>

                        </div>
                        <!--end card-body-->
                    </div>
                    <!--end card-->
                </div>
                <!--end col-->
            </div>
        </div>
    </AuthenticatedLayout>
</template>